<?
function YT_ListByTag($keyword, $page=1) {
  global $config;

  $keyword = urlencode($keyword);

  $start_index = ($page - 1) * $config['list_per_scroller'] + 1;

  $req = "http://gdata.youtube.com/feeds/videos?vq={$keyword}".
        "&start-index={$start_index}".
        "&max-results={$config['list_per_scroller']}".
        "&racy=exclude".
        "&orderby=updated";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetDetail($video_id) {
  global $config;

  $req = "http://gdata.youtube.com/feeds/videos/{$video_id}";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetComment($video_id) {
  global $config;

  $req = "http://gdata.youtube.com/feeds/videos/{$video_id}/comments";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetUserProfile($user) {
  global $config;

  $req = "http://gdata.youtube.com/feeds/api/users/{$user}";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetUserUpload($user, $page=1, $max_result=10) {
  global $config;

  $start_index = ($page - 1) * $max_result + 1;

  $req = "http://gdata.youtube.com/feeds/api/users/{$user}/uploads".
         "?start-index={$start_index}".
        "&max-results={$config['user_uploaded_list_per_page']}".
        "&racy=exclude".
         "&orderby=updated";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetUserFavorites($user, $page=1, $max_result=10) {
  global $config;

  $start_index = ($page - 1) * $max_result + 1;

  $req = "http://gdata.youtube.com/feeds/api/users/{$user}/favorites".
         "?start-index={$start_index}".
        "&max-results={$config['user_favorites_list_per_page']}".
        "&racy=exclude".
         "&orderby=updated";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetUserPlaylists($user, $page=1, $max_result=10) {
  global $config;

  $start_index = ($page - 1) * $max_result + 1;

  $req = "http://gdata.youtube.com/feeds/api/users/{$user}/playlists".
         "?start-index={$start_index}".
        "&racy=exclude".
         "&max-results={$max_result}";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetUserPlaylistsEntry($id, $page=1, $max_result=10) {
  global $config;

  $start_index = ($page - 1) * $max_result + 1;

  $req = "http://gdata.youtube.com/feeds/api/playlists/{$id}".
         "?start-index={$start_index}".
        "&racy=exclude".
         "&max-results={$max_result}";

  if($config['xml_cache_enable']) {
    $data[1] = YT_GetXMLRespCache($req);
  }
  else {
    $data[1] = REST_Request($req);
  }

  $data[0] = Xml2Array($data[1]);

  return $data;
}

function YT_GetXMLRespCache($req) {
  global $config;

  $filename = $config['xml_cache_dir'] . md5($req) . ".txt";

  // read cache file if possible
  if ((file_exists($filename) && (filemtime($filename) < $config['xml_cache_timeout']))) {
    $xml = file_get_contents($filename);
  }

  // if not, send request and create file
  else {
    $xml = REST_Request($req);
    WriteToFile($filename, $xml);
  }

  return $xml;
}

function REST_Request($url) { 
  if (function_exists('curl_init')) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $xml = curl_exec($ch);
    curl_close($ch);
  } 
  else {
    $xml =  file_get_contents($url);
  }
  
  return $xml;
}
?>